/*
     This file is part of Advanced Strategic Command; http://www.asc-hq.org
     Copyright (C) 1994-2010  Martin Bickel 
 
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
     (at your option) any later version.
 
     This program is distributed in the hope that it will be useful,
     but WITHOUT ANY WARRANTY; without even the implied warranty of
     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
     GNU General Public License for more details.
 
     You should have received a copy of the GNU General Public License
     along with this program; see the file COPYING. If not, write to the 
     Free Software Foundation, Inc., 59 Temple Place, Suite 330, 
     Boston, MA  02111-1307  USA
*/

#ifndef abstracttaskcontainerH
#define abstracttaskcontainerH

#include "../gamemap.h"

class tnstream;
class Task;


class AbstractTaskContainer {
   protected:
      static const int taskMagic = 0xda5cda5c;
      MemoryStreamStorage* playerTasks[GameMap::maxTotalPlayers];
      MemoryStreamStorage* newTasks;
      
      void writeStorage( tnstream& stream ) const;
      void readStorage( tnstream& stream );
      
      int lastPlayer;
      AbstractTaskContainer();
   public:
      virtual void read ( tnstream& stream ) = 0; 
      virtual void write ( tnstream& stream ) const = 0;
      virtual ~AbstractTaskContainer();
};

#endif
